<template>
  <component
    :is="tag || 'div'"
    :class="{ 'Radio--HasChanged': hasChanged }"
    class="Radio"
  >
    <span v-if="label" class="Radio__Label">{{ label }} </span>

    <div v-for="(value, label) in options" :key="label" class="Radio__Option">
      <!--suppress HtmlFormInputWithoutLabel -->
      <input
        :id="uuid + '_' + label"
        :checked="value === modelValue"
        :name="uuid"
        :value="value"
        class="Radio__OptionInput"
        type="radio"
        @input="$emit('update:modelValue', value)"
      />
      <label :for="uuid + '_' + label" class="Radio__OptionLabel">{{
        noTranslate ? label : t(label)
      }}</label>
    </div>
  </component>
</template>

<script lang="ts">
import { defineComponent, PropType } from 'vue'
import { isControl, ControlEmits } from '@/components/controls/mixins'

export default defineComponent({
  name: 'RadioButton',
  emits: [...ControlEmits],
  props: {
    tag: String,
    label: String,
    modelValue: null,
    restoreValue: null,
    options: Object as PropType<Record<string, object>>,
    noTranslate: Boolean,
    debounceDelay: Number,
  },

  setup(props, context) {
    return {
      ...isControl<unknown>({ props, context }),
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;
@use './mixins/control' as c;

.Radio {
  @include c.control;

  position: relative;
  display: inline-flex;
  flex-wrap: wrap;
  align-items: center;
  padding: v.$spacing;
  border-radius: v.$borderRadius;

  &__Label {
    width: 100%;
    font-weight: bold;
  }

  &__Option {
    padding: v.$spacing-2;

    &Label {
      margin-left: v.$spacing-2;
      cursor: pointer;
    }

    &Input {
      cursor: pointer;
    }
  }
}
</style>
